function C = input_medit(V,F,C)
  % Gather boundary and non-manifold edges
  NME = nonmanifold_edges(F);
  BE = outline(F);
  BE = setdiff(BE,NME,'rows');
  E = [NME 1+0*NME(:,1); ...
        BE 2+0*BE(:,1);];
  if ~exist('C') || isempty(C)
    C = randcycle(connected_components(F));
    % hack so that not all equal (medit doesn't like that)
    if all(C==C(1))
      C(ceil(rand*size(C,1))) = C(1)+1;
    end
  end
  if size(C,1)<size(V,1)
      C(size(V,1)) = 0;
      C(C==0) = max(C(:))+1;
  end
  % Gather self-intersecting faces
  [~,~,IF] = selfintersect(V,F,'DetectOnly',true);
  F = [F full(0<sparse(IF(:),1,1,size(F,1),1))];
  medit(V,[],F,'Data',C,'Edges',E,'Wait',false);
end
