//file debug.cpp
#include "Debug.h"

#include <stdio.h>
#include <stdarg.h>
#ifndef __APPLE__
#  include <windows.h>
#endif
#include <mex.h> // for MATLAB

//FILE *g_traceFile = NULL;

#define TRACE_TO_MATLAB
//#define TRACE_TO_IDE
//#define TRACE_TO_FILE
//#define TRACE_TO_STDOUT
#ifdef __APPLE__
#define VSPRINTF vsprintf
#else
#define VSPRINTF vsprintf_s
#endif

#ifdef TRACE_TO_MATLAB
inline void CDECL myTrace(char *fmt, ...)
{
	char out[1024];
	va_list body;
	va_start(body, fmt);
	VSPRINTF(out, fmt, body);
	va_end(body);	
	mexPrintf("%s", out);
	fflush(stdout);
}
#endif

#ifdef TRACE_TO_FILE
inline void CDECL myTrace(char *fmt, ...)
{
	//if (!g_traceFile)
	//{
	//	g_traceFile = fopen("traceLog.txt", "wt");
	//}

	//char out[1024];
	//va_list body;
	//va_start(body, fmt);
	//VSPRINTF(out, fmt, body);
	//va_end(body);
	//fprintf(g_traceFile, "%s", out);	
	//fflush(g_traceFile);
}
#endif

#ifdef TRACE_TO_STDOUT
inline void CDECL myTrace(char *fmt, ...)
{
	char out[1024];
	va_list body;
	va_start(body, fmt);
	VSPRINTF(out, 1024, fmt, body);
	va_end(body);
	fprintf(stdout, "%s", out);	
	fflush(stdout);
}
#endif

#ifdef TRACE_TO_IDE
inline void CDECL myTrace(char *fmt, ...)
{
	char out[1024];
	va_list body;
	va_start(body, fmt);
	VSPRINTF(out, 1024, fmt, body);
	va_end(body);
	OutputDebugStringA(out);
}
#endif


inline void CDECL odprintf(const char *format, ...)
{
	//char out[1024];
	//va_list body;
	//va_start(body, format);
	//VSPRINTF(out, format, body);
	//va_end(body);
	//OutputDebugStringA(out);
}

/*
void CDECL myTrace(TCHAR *fmt, ...)
{
	TCHAR out[1024];
	va_list body;
	va_start(body, fmt);
	vswprintf_s(out, 1024, fmt, body);
	va_end(body);
	OutputDebugString(out);
}


void CDECL odprintf(const TCHAR *format, ...)
{
	TCHAR out[1024];
	va_list body;
	va_start(body, format);
	vswprintf_s(out, 1024, format, body);
	va_end(body);
	OutputDebugString(out);
}
*/
